/*----------------------------------------------------------------------------*/
/*
    : compile.c
    :  -      
     :  .., .
      : 21.07.08-01:18
*/
/*----------------------------------------------------------------------------*/
#ifndef compile_c_E
#define compile_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
       .
*/
void stdword_cbegin(struct fws* ws)
    {
	fword* w;
	if(ws->flags & FWS_COMPILE){SETERROR(ws,AFER_INTERPONLY);return;}
	//   
	if(get_next_word(ws)!=LEXT_UNKNOWN)
	    {
		//     .
		SETERROR(ws,AFER_USEDWORD);
		return;
	    }
	//  .
	if(!(ws->cword = (w = add_new_word_space(ws)))){SETERROR(ws,AFER_NOMEMORY);return;}
	w->name = strdup(ws->unknown);
	w->type = WTYPE_VIRTUAL;
	//
	ws->flags |= FWS_COMPILE;
	dmsg("  : %s\n",ws->cword->name);
    }
/*----------------------------------------------------------------------------*/
/*
       .
*/
void stdword_cend(struct fws* ws)
    {
	int mean;
	if(!(ws->flags & FWS_COMPILE)){SETERROR(ws,AFER_COMPONLY);return;}
	//       -  .
	if(from_sstk(ws, &mean)>=0){SETERROR(ws,AFER_STATEMENT);}
	//
	ws->flags &= ~FWS_COMPILE;
	dmsg("  : %s\n",ws->cword->name);
    }
/*----------------------------------------------------------------------------*/
/*
       .
    
	"test.frt" include
*/
void stdword_include(struct fws* ws)
    {
	//     
	char	old_inbuf[MAXLINESIZE]; // ,    .
	char*	old_curchar; //    .
	//
	vcode vmean;
	fword* w;
	if(ws->flags & FWS_COMPILE){SETERROR(ws,AFER_INTERPONLY);return;}
	if(from_vstk(ws, &vmean)>=0)
	    {
		//   
		memcpy(old_inbuf,ws->inbuf,MAXLINESIZE);old_curchar=ws->curchar;
		switch(vmean.type)
		    {
			case WTYPE_CSTR:{do_file(ws,vmean.svar);break;}
			case WTYPE_STR:
			    {
				if(w=get_nword(ws, vmean.word)){do_file(ws,w->svar);}
				break;
			    }
			default:
			    {
				SETERROR(ws,AFER_INTERPONLY);
				break;
			    }
		    }
		//  
		memcpy(ws->inbuf,old_inbuf,MAXLINESIZE);ws->curchar=old_curchar;
	    }
	clear_vcode(&vmean);
    }
/*----------------------------------------------------------------------------*/
#endif /* compile_c_E */
