/*----------------------------------------------------------------------------*/
/*
    : ifcond.c
    :  
     :  .., .
      : 11.03.08-11:57
*/
/*----------------------------------------------------------------------------*/
#ifndef ifcond_c_E
#define ifcond_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*     if */
void stdword_if(struct fws* ws)
    {
	struct vcode v={0,0};
	// ,     
	if(!(ws->flags & FWS_COMPILE)){SETERROR(ws,AFER_COMPONLY);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_IF;
	v.word = find_nword(ws, "if_run");
	//
	if(do_compile_add(ws, &v)>=0){if(to_sstk(ws, v.type)<0){SETERROR(ws,AFER_SSTKOVF);}}
	//
	dmsg("if : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*
     ӣ  else  endif,   .
*/
void stdword_if_pass_to(vcode** cmd)
    {
	int level=0;
	while(1)
	    {
		if((!level)&&(GETFASTCMD(*cmd)==FCMD_ELSE)){break;}
		if(GETFASTCMD(*cmd)==FCMD_ENDIF)
		    {
			if(!level){break;}
			else{level--;}
		    }
		if(GETFASTCMD(*cmd)==FCMD_IF){level++;}
		(*cmd)++;
	    }
    }
/*----------------------------------------------------------------------------*/
/*     if */
void stdword_if_run(struct fws* ws)
    {
	dmsg("if (runtime) \n");
	//
	vcode v1;
	vcode* cmd=(ws->ccmd)+1;
	if(get_local_copy(ws,&v1)<0){return;}
	//
	ws->rcode=NULL;
	if(v1.ivar)
	    {
		//  ӣ  else  endif
		while( (GETFASTCMD(cmd)!=FCMD_ELSE) && (GETFASTCMD(cmd)!=FCMD_ENDIF) )
		    {
			ws->ccmd=cmd;
			run_vm_onecmd(ws, cmd);
			if(ws->rcode){cmd=ws->rcode;ws->rcode=NULL;}else{cmd++;}
			if(ws->error){break;}
		    }
		//  ӣ  
		if(GETFASTCMD(cmd)==FCMD_ELSE){cmd++;stdword_if_pass_to(&cmd);}
	    }
	else
	    {
		//  ӣ  else  endif
		stdword_if_pass_to(&cmd);
		//  ӣ  endif
		if(GETFASTCMD(cmd)==FCMD_ELSE)
		    {
			cmd++;
			while((GETFASTCMD(cmd)!=FCMD_ENDIF))
			    {
				ws->ccmd=cmd;
				run_vm_onecmd(ws, cmd);
				if(ws->rcode){cmd=ws->rcode;ws->rcode=NULL;}else{cmd++;}
				if(ws->error){break;}
			    }
		    }
	    }
	clear_vcode(&v1);
	ws->rcode = ++cmd;
	//
    }
/*----------------------------------------------------------------------------*/
/*     else */
void stdword_else(struct fws* ws)
    {
	struct vcode v={0,0};
	int mean;
	int ret=from_sstk(ws, &mean);
	//
	if((ret<0)||((mean&FCMD_MASK)!=FCMD_IF)){SETERROR(ws,AFER_ELSEWIF);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_ELSE;
	v.word = find_nword(ws, "else_run");
	//
	if(do_compile_add(ws, &v)>=0){if(to_sstk(ws, v.type)<0){SETERROR(ws,AFER_SSTKOVF);}}
	//
	dmsg("else : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
/*     endif */
void stdword_endif(struct fws* ws)
    {
	struct vcode v={0,0};
	int mean;
	int ret=from_sstk(ws, &mean);
	//
	if((ret<0) || (((mean&FCMD_MASK)!=FCMD_IF) && ((mean&FCMD_MASK)!=FCMD_ELSE))){SETERROR(ws,AFER_ENDIFWIF);return;}
	//
	v.type = WTYPE_NATIVE | FCMD_ENDIF;
	v.word = find_nword(ws, "endif_run");
	//
	do_compile_add(ws, &v);
	//
	dmsg("endif : 0x%x 0x%x\n",v.type,v.word);
    }
/*----------------------------------------------------------------------------*/
#endif /* ifcond_c_E */
