/*----------------------------------------------------------------------------*/
/*
    : printmisc.c
    :     
     :  .., .
      : 21.07.08-01:26
*/
/*----------------------------------------------------------------------------*/
#ifndef printmisc_c_E
#define printmisc_c_E
/*----------------------------------------------------------------------------*/
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
      
     base = 10   -  10 
     base = 16   -  16  ( )
     base = 144  -  16  ( )
     base = -1   -   ,    (  INT)
*/
void stdword_printstk(struct fws* ws, int base)
    {
	vcode vmean;
	if(from_vstk(ws, &vmean)>=0)
	    {
		fword* w;
		if(!ISCONST(&vmean)){w = get_nword(ws,vmean.word);}
		//
		switch(vmean.type)
		    {
			case WTYPE_INT:
			    {
				if(base==10){printf("%i",w->ivar);}
				else if(base==16){printf("%x",w->ivar);}
				else if(base==(16+0x80)){printf("%X",w->ivar);}
				else if(base==-1){printf("%c",w->ivar);}
				break;
			    }
			case WTYPE_REAL:{printf("%f",w->fvar);break;}
			case WTYPE_STR:{printf("%s",w->svar);break;}
			case WTYPE_CINT:
			    {
				if(base==10){printf("%i",vmean.ivar);}
				else if(base==16){printf("%x",vmean.ivar);}
				else if(base==(16+0x80)){printf("%X",vmean.ivar);}
				else if(base==-1){printf("%c",vmean.ivar);}
				break;
			    }
			case WTYPE_CREAL:{printf("%f",vmean.fvar);break;}
			case WTYPE_CSTR:{printf("%s",vmean.svar);break;}
		    }
		clear_vcode(&vmean);
	    }
    }
//
void stdword_dprintstk(struct fws* ws){stdword_printstk(ws, 10);}
void stdword_hprintstk(struct fws* ws){stdword_printstk(ws, 16);}
void stdword_Hprintstk(struct fws* ws){stdword_printstk(ws, 16+0x80);}
void stdword_Cprintstk(struct fws* ws){stdword_printstk(ws, -1);}
/*----------------------------------------------------------------------------*/
#endif /* printmisc_c_E */
