/*----------------------------------------------------------------------------*/
/*
    : carrays.c
    :     
     :  .., .
      : 25.07.08-12:55
*/
/*----------------------------------------------------------------------------*/
#ifndef carrays_c_E
#define carrays_c_E
/*----------------------------------------------------------------------------*/
//#undef  DEBUGLEVEL
//#define DEBUGLEVEL 3
#include <aforth.h>
/*----------------------------------------------------------------------------*/
/*
     {
      
*/
void stdword_carrbegin(struct fws* ws)
    {
	if(ws->flags & FWS_COMPILE){SETERROR(ws,AFER_INTERPONLY);return;}
	if(ws->flags & FWS_CONSTARRAY){SETERROR(ws,AFER_UWORD);return;}
	ws->flags |= FWS_CONSTARRAY;
	//  -  
	ws->array=NULL;
	ws->arr_int_sz=sizeof(int);
	//
	dmsg("  .\n");
    }
/*----------------------------------------------------------------------------*/
/*
     }
      
*/
void stdword_carrend(struct fws* ws)
    {
	if(ws->flags & FWS_COMPILE){SETERROR(ws,AFER_INTERPONLY);return;}
	if(!(ws->flags & FWS_CONSTARRAY)){SETERROR(ws,AFER_UWORD);return;}
	ws->flags &= ~FWS_CONSTARRAY;
	//  -  .
	vcode v={WTYPE_CARRAY };
	v.svar = ws->array;
	to_vstk(ws,&v);
	// 
	ws->array=NULL;
	//
	dmsg("  .\n");
    }
/*----------------------------------------------------------------------------*/
/*
         .
*/
void stdword_set_arr_int_size(struct fws* ws, int n)
    {
	if(ws->flags & FWS_COMPILE){SETERROR(ws,AFER_INTERPONLY);return;}
	if(!(ws->flags & FWS_CONSTARRAY)){SETERROR(ws,AFER_UWORD);return;}
	ws->arr_int_sz=n;
    }
/*----------------------------------------------------------------------------*/
/*
         
      
*/
void stdword_byte(struct fws* ws){stdword_set_arr_int_size(ws, sizeof(char));}
/*----------------------------------------------------------------------------*/
/*
         
       
*/
void stdword_short(struct fws* ws){stdword_set_arr_int_size(ws, sizeof(short));}
/*----------------------------------------------------------------------------*/
/*
         
      
*/
void stdword_int(struct fws* ws){stdword_set_arr_int_size(ws, sizeof(int));}
/*----------------------------------------------------------------------------*/
#endif /* carrays_c_E */
