/*----------------------------------------------------------------------------*/
/*
    : rstk.c
    :    
     :  .., .
      : 10.03.08-14:27
*/
/*----------------------------------------------------------------------------*/
#ifndef rstk_c_E
#define rstk_c_E
//#define DEBUGLEVEL 3
/*----------------------------------------------------------------------------*/
#include <aforth.h>
#include <string.h>
#include <stdlib.h>
#include <debug.h>
#include <rstk.h>
/*----------------------------------------------------------------------------*/
/*
     rstk
*/
int init_rstk(struct fws* ws)
    {
	ws->rstk = malloc(RSTK_SIZE*sizeof(struct vcode*));
	if(ws->rstk){dmsg("rstk \n");ws->rstk_top=-1;}
	else{dmsg("rstk  \n");return(-1);}
	ws->rstk_top=-1;
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
     rstk
*/
int done_rstk(struct fws* ws)
    {
	free(ws->rstk);
	ws->rstk =NULL;
	dmsg("rstk ̣\n");
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        .
    -1 - 
     0 -ӣ  
*/
int to_rstk(struct fws* ws, struct vcode* radr)
    {
	if(ws->rstk_top >= (RSTK_SIZE-1))
	    {
		SETERROR(ws,AFER_RSTKOVF);
		return(-1);
	    }
	else
	    {
		ws->rstk_top ++;
		ws->rstk[ws->rstk_top] = radr;
		dmsg("to_rstk top=%i\n",ws->rstk_top);
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
/*
        .
    -1 - 
     0 -ӣ  ,  radr -   
*/
int from_rstk(struct fws* ws, struct vcode** radr)
    {
	if(ws->rstk_top < 0)
	    {
		SETERROR(ws,AFER_RSTKEMPTY);
		return(-1);
	    }
	else
	    {
		*radr=ws->rstk[ws->rstk_top];
		ws->rstk_top--;
		dmsg("from_rstk top=%i\n",ws->rstk_top);
	    }
	return(0);
    }
/*----------------------------------------------------------------------------*/
#endif /* rstk_c_E */
